Feature: execute step

  Scenario: execute simple non-failing step with parameters
    Given I have a running auton with one defined step with parameters
    When I add the step with parameters to the execution queue
    And I wait for the step to execute
    Then the Auton should be in the READY state
    And the execution result should be returned

  Scenario: execute simple non-failing step with parameters
    Given I have a running auton with one defined step with parameters
    When I add the step with parameters to the execution queue
    And I wait for the step to execute
    Then the Auton should be in the READY state
    And the execution result should be returned

  Scenario: execute simple failing step
    Given I have a running auton with one defined step that fails
    When I add the step to the execution queue
    And I wait for the step to execute
    Then the auton should be in the FAILED state
    And the execution result should be an exception

  Scenario: stop execution when in FAILED state
    Given I have a running auton with one defined step that fails and one that does not fail
    When I add first the failing and then the not failing step to the execution queue
    And I wait for the first step to execute
    Then the auton should be in the FAILED state
    And the execution result should be an exception
    And the not failing step will not be executed

  Scenario: repeating failed step
    Given I have a running auton with one defined step that fails on the first invocation but succeeds on the second
    When I add the step to the execution queue
    And I wait for the step to execute
    And I repeat the failed step
    And I wait for the step to execute
    Then the execution result should be returned
    And the Auton should be in the READY state

  Scenario: resuming after failure
    Given I have a running auton with one defined step that fails and one that does not fail
    When I add first the failing and then the not failing step to the execution queue
    And I wait for the first step to execute
    Then the auton should be in the FAILED state
    When I resume the failed auton
    And I wait for the second step to execute
    Then the execution result should be returned
    And the Auton should be in the READY state

  Scenario: handling exception by Auton
    Given I have a running auton with one defined step that fails and one that does not fail and an exception handling method for the whole Auton
    When I add first the failing and then the not failing step to the execution queue
    And I wait for the first step to execute
    And I wait for the second step to execute
    Then the execution result should be returned
    And the Auton should be in the READY state
    And the "handle_exception" method should have been executed

