ENV['RACK_ENV'] = 'test'
require "rack/test"
require 'nestene'
require 'capybara/cucumber'
require 'capybara/poltergeist'
require 'pry'
require 'timeout'
Capybara.javascript_driver = :poltergeist

Capybara.app = Nestene::Ui::App

Capybara.register_driver :rack_test do |app|
  Capybara::RackTest::Driver.new app, \
    redirect_limit: 15,
    follow_redirects: false,
    respect_data_method: true
end

Before do
  Celluloid.shutdown
  Celluloid.boot
  @storage = Nestene::MemoryStorage.new
  Nestene::start_nestene(@storage)
end

class MyWorld
  include Rack::Test::Methods
  def app
    Nestene::Ui::App
  end
end

World do
  MyWorld.new
end


